Viewing Issue Advanced Details Jump to Notes ]
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
04368 Crash/Freeze Major Always Jun 7, 2011, 06:33 Nov 3, 2011, 03:16
Tester abelenki View Status Public Platform MAME (Self-compiled)
Assigned To Resolution Fixed OS Windows Vista/7 (64-bit)
Status [?] Resolved   Driver
Version 0.142u5 Fixed in Version 0.143 Build 64-bit
Summary 04368: can't redefine controls in input (this game)
Description i have problems with new input system on u5.

i defined new default.cfg for my 4 gamepads and 1 keyboard from scratch in u5.

but when i use it, i can't redefine controls in input (this game) from gamepad - they all show as n/a, and then mame crash on exit.
Steps To Reproduce Super simple repro:

load tempest
input (this game)
Dial Analog
Enter, ESC, Enter, ESC
ESC, ESC, ESC to leave MAME == crash
Additional Information
Flags
Regression Version
Affected Sets / Systems
Attached Files
zip file icon test.zip (3,029 bytes)  Jun 7, 2011, 15:33 by Fujix
Please test this.
txt file icon gdboutput.txt (47,724 bytes)  Jun 7, 2011, 15:34 by Tafoid
Full backtrace with 0.142u5 build [Show Content]
zip file icon default.zip (3,378 bytes)  Jul 2, 2011, 12:02 by abelenki
current controller configuration file
zip file icon mame.zip (1,997 bytes)  Jul 2, 2011, 12:03 by abelenki
current MAME configuration file


-  Notes
User avatar
No.07504
abelenki
(Tester)
Jun 7, 2011, 06:40
one more note: i don't have any .cfg files from previous MAME versions. only fresh default.cfg which i created in u5.
User avatar
No.07505
Fujix
(Administrator)
Jun 7, 2011, 11:42
We need your -verbose output to determine your controller set up and seek out the cause.
Also, please find out which line causes the problem by editing the default.cfg manually with your current input devices.

Thank you.
User avatar
No.07506
abelenki
(Tester)
Jun 7, 2011, 13:16
edited on: Jun 7, 2011, 13:18
here's my verbose (after crash) with bublbobl:

http://pastebin.com/TEwuXK7D

> Also, please find out which line causes the problem by editing the default.cfg manually with your current input devices.

i don't really understand what you mean. if i knew what causes the problem, i won't submit a bug report.

User avatar
No.07507
Fujix
(Administrator)
Jun 7, 2011, 14:29
edited on: Jun 7, 2011, 14:30
I think I found the cause of the trouble. It is "JOYCODE_*_HATSWITCH*".

If I remove any usages of JOYCODE_[2-4]_HATSWITCH* from your default.cfg, it works without the problem. I don't know why for now. Could you check this?

JOYCODE_1_HATSWITCH* is working for me.

User avatar
No.07508
abelenki
(Tester)
Jun 7, 2011, 14:42
edited on: Jun 7, 2011, 14:44
i just checked:

i re-defined all positional controls in Input (General) not to use hat switch (which is d-pad), and used only analog joysticks (e.g. JOYCODE_1_YAXIS_UP_SWITCH).

then i tried to re-define the same controls in Input (This game). it became N/A again, and MAME crashed.

p.s.: the bottom-line is - everything worked fine for many MAME versions before u5. something went wrong after input system changes in u5.

User avatar
No.07509
abelenki
(Tester)
Jun 7, 2011, 14:49
to clarify:

this happens, if i redefine the same input in Input (This game). e.g.:

i have this in Input (General):

            <port type="P1_JOYSTICK_UP">
                <newseq type="standard">
                    JOYCODE_1_YAXIS_UP_SWITCH

then i try to redefine the up controls in Input (This game) with the same controls (JOYCODE_1_YAXIS_UP_SWITCH), it becomes N/A, and MAME crashes on exit.
User avatar
No.07510
Tafoid
(Administrator)
Jun 7, 2011, 14:58
I'll acknowledge this for now.
Since it's unlikely most people do not have the controllers/input coverage that you do to populate your .cfg file, (most have access to 1.. maybe 2 controllers), you'll need to do some experiments to help determine what in your .cfg is causing MAME to be unable to write (and cause the resultant crash). There is only so much we can do in this situation.
User avatar
No.07511
abelenki
(Tester)
Jun 7, 2011, 15:07
yeah, i'm open to help. just let me know, what i need to test and i will report back.
User avatar
No.07512
abelenki
(Tester)
Jun 7, 2011, 15:15
also, i reuploaded my default.cfg. it had wrongly assigned controls for player 4.
User avatar
No.07513
Tafoid
(Administrator)
Jun 7, 2011, 15:33
Added my gdboutput.txt log with a full backtrace of the crash I get on exit. Should help a dev identify the issue. Problem is we don't know for sure if it's mangling it upon loading or while preparing it to save.
User avatar
No.07514
Fujix
(Administrator)
Jun 7, 2011, 15:36
edited on: Jun 7, 2011, 15:38
Anton, please test my upload. I removed JOYCODE_[2-4]_HATSWITCH* from following definitions, and this file is working for me:
            <port type="UI_UP">
                <newseq type="standard">
                    KEYCODE_UP OR JOYCODE_1_HATSWITCHU
                </newseq>
            </port>
            <port type="UI_DOWN">
                <newseq type="standard">
                    KEYCODE_DOWN OR JOYCODE_1_HATSWITCHD
                </newseq>
            </port>
            <port type="UI_LEFT">
                <newseq type="standard">
                    KEYCODE_LEFT OR JOYCODE_1_HATSWITCHL
                </newseq>
            </port>
            <port type="UI_RIGHT">
                <newseq type="standard">
                    KEYCODE_RIGHT OR JOYCODE_1_HATSWITCHR
                </newseq>
            </port>

User avatar
No.07515
B2K24
(Moderator)
Jun 7, 2011, 15:40
I can reproduce this issue if I launch mame64 self compiled 0.142u5 with anything in cfg directory. I'm using a n64 joypad with PSX + N64 USB converter.

However, if you delete everything in directory cfg before launching mame64 everything works fine until the point of having to re launch mame64 with config files in cfg directory.
User avatar
No.07516
abelenki
(Tester)
Jun 7, 2011, 15:51
edited on: Jun 7, 2011, 15:52
Fujix, tried your default.cfg and still have the same problem. if i redefine the same controls for my gamepad in Input (this game), it reverts to N/A, then crashes on exit.

User avatar
No.07517
abelenki
(Tester)
Jun 7, 2011, 16:05
also, i uploaded my mame.ini (if it helps).
User avatar
No.07534
dukejp
(Tester)
Jun 13, 2011, 22:52
I can confirm this bug. You can customize your "general" joystick config, but mame crashes at exit if you customize "this game" joystick configuration. (in my case, sf2ce.)
User avatar
No.07555
abelenki
(Tester)
Jun 20, 2011, 01:33
edited on: Jun 20, 2011, 01:34
it isn't mentioned in whatsnew, but the bug is fixed in u6.

i can finally remap gamepad controls in Input (This game) without N/A and crash.

many thanks to everyone involved!!

User avatar
No.07556
Tafoid
(Administrator)
Jun 20, 2011, 01:43
I think there are other issues with this which is why it wasn't immediately set as resolved. There was more work to be done but it didn't get done before u6 happened. Once I see it's truly fixed properly, I'll make sure this gets marked as such.
User avatar
No.07612
R. Belmont
(Developer)
Jul 1, 2011, 14:28
The N/A and crash problems were the "default input" thing that Aaron fixed. Justify leaving this open or delete :)
User avatar
No.07614
Tafoid
(Administrator)
Jul 1, 2011, 15:38
OG fixed the initial crash problem with what he termed it was a "bandaid" (r12858). I didn't notice Aaron's proper fix which seems to have come after u6 was released (r12940). I'll resolve for 0.143 as a result.
User avatar
No.07621
abelenki
(Tester)
Jul 2, 2011, 06:20
edited on: Jul 2, 2011, 06:23
actually, the bug is not fixed at all on 0.143. MAME and MESS still crash a lot when trying to define Input (this game) via gamepads.

and it's getting real annoying.

when i'm trying to define Input (this game) on a800, MESS crashes while i'm moving cursor up and down on UI.

when i detached fourth gamepad from my system, and 4th gamepad is still set in default.cfg, MAME crashes on EVERY exit.

User avatar
No.07623
Fujix
(Administrator)
Jul 2, 2011, 11:43
Reopened the report.
User avatar
No.07624
abelenki
(Tester)
Jul 2, 2011, 12:00
edited on: Jul 2, 2011, 12:05
thanks, Fujix.

can anyone confirm that again?

(i re-uploaded default.cfg and mame.ini).

p.s..: anyway, that case happens not THAT often as before, but still the bug appears not to be fixed.

User avatar
No.07861
Tafoid
(Administrator)
Nov 2, 2011, 21:09
abelenki, please see if this is still a problem in 0.143u9 with fresh .cfg files made (not stuff imported from earlier versions). I'd be curious if this is still a recurring issue.
User avatar
No.07862
Tafoid
(Administrator)
Nov 3, 2011, 03:16
Unsure when it was fixed, but as of 0.143u6, things work as expect for OP.
Resolving